/*

                         \\\|///
                       \\  - -  //
                        (  @ @  )
+---------------------oOOo-(_)-oOOo-------------------------+
|                                                           |
|                       PCF8833.c                           |
|                     by Xiaoran Liu                        |
|                        2005.3.16                          |
|                                                           |
|                    ZERO research group                    |
|                        www.the0.net                       |
|                                                           |
|                            Oooo                           |
+----------------------oooO--(   )--------------------------+
                      (   )   ) /
                       \ (   (_/
                        \_)     

*/
#ifndef __PCD5544_H__
#define __PCD5544_H__


/* LCD color */
#define White          0xFFFF
#define Black          0x0000
#define Grey           0xF7DE
#define Blue           0x001F
#define Blue2          0x051F
#define Red            0xF800
#define Magenta        0xF81F
#define Green          0x07E0
#define Cyan           0x7FFF
#define Yellow         0xFFE0

// How many pixel height including empty pixels, if you like to get more space between the lines rise this number


/* Exported functions ------------------------------------------------------- */
extern volatile unsigned char Font;

/*----- High layer function -----*/
void LCD_Init(void);
 void  Delay(unsigned int  dly);
void LCD_Clear_Screen( unsigned short Color );
void LCD_Cls( unsigned int Color );
void LCD_SPI_DBCommand(const unsigned int data[], unsigned int count);
void LCD_SPI_Byte(const unsigned char data[], unsigned int count);
void LCD_SPI_Int(unsigned int Value);
void LCD_Window(int x1, int y1, int x2, int y2);
void LCD_Plot(unsigned char x1, unsigned char y1, unsigned char line_type, unsigned int color);
void LCD_RectangleFill( unsigned short x0, unsigned short y0, unsigned short x1, unsigned short y1, unsigned short Color );
void LCD_SetPixel( unsigned short x, unsigned short y, unsigned short Color );

void LCD_PutChar8x16(unsigned short x, unsigned short y,  char c, unsigned int f, unsigned int b);
void LCD_PutChar8x8(unsigned short x, unsigned short y, char c, unsigned int f, unsigned int b);
void LCD_PutChar(unsigned short x, unsigned short y, char c, unsigned int f, unsigned int b);
void put_char(unsigned char x, unsigned char y,  char *c, unsigned int textcolor,unsigned char rotation);
void LCD_PutString(unsigned short x, unsigned short y, char *s, unsigned int f, unsigned char rotation);

#endif

